/* Copyright (c) by DATATEC Computer u. Elektronik GmbH

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

/******************************************************************
**
** MyObj.cpp for BackUp.cpp DLL version 1.0
**
** Author Ch. Friedrich 20.5.2001
**
** Dependencies: libmysql.dll
** Output:       MyBackUp.dll
**
*******************************************************************/


#include "MyObj.h"


int TMySQLObj::ConnectServer(char *host,char *user,char *passwd)
{
  MySock = NULL;
  MySock = mysql_init((MYSQL*) 0);
  mysql_options(MySock, MYSQL_OPT_COMPRESS, NULL);
  Connected=0;
  if ( ! mysql_connect(MySock, host,user,passwd) )
  {
     strcpy(MyErrStr, ConnectErr);
     MyErrNo=0;
     return 1;
  }
  return 0;
}


PMYSQL TMySQLObj::RealConnectServer(char *host,char *user,char *passwd,char *db)
{
  MySock = NULL;
  MySock = mysql_init((MYSQL*) 0);
  mysql_options(MySock, MYSQL_OPT_COMPRESS, NULL);
  Connected=0;
  if ( ! mysql_real_connect(MySock, host,user,passwd,db,0,NULL,0))
//                           opt_mysql_port,opt_mysql_unix_port,0))
  {
     strcpy(MyErrStr, ConnectErr);
     MyErrNo=0;
     return NULL;
  }
  Connected=1;
  return MySock;
}

// Return Values:
// Zero if the server is alive. Non-zero if an error occurred.
int TMySQLObj::PingServer(void)
{
  if ( MySock )
  {
    return mysql_ping(MySock);
  }
  return 1;
}


void TMySQLObj::DisConnect(void)
{
  if ( MySock )
  {
    if (PSQLRes) mysql_free_result(PSQLRes);
    mysql_close(MySock);
    Connected=0;
    MySock=NULL;
  }
}

// Res. 0 is OK
int TMySQLObj::SelectDB(char *database)
{
 if ( Connected)
  {
    if( mysql_select_db(MySock, database ) )
    {
      GetMyErr();
      return -1;
    }
    return 0;
  }
  return 0;
}


void TMySQLObj::GetMyErr(void)
{
  if (MySock)
  {
    if (PSQLRes) mysql_free_result(PSQLRes) ;
    PSQLRes =NULL;
    PMyRow =NULL;
    ResFindDB=0;
    NumRows=0;
    strcpy(MyErrStr, mysql_error(MySock));
    MyErrNo=mysql_errno(MySock);
  }
  else
  {
    strcpy(MyErrStr, "SQL-Error");
    MyErrNo=1;
  }
}

// Result: if Error: -1, else EffectedRows
int TMySQLObj::ExecSQL(char *sql)
{
  PSQLRes = NULL;
  if ( MySock )
  {
   if (mysql_query(MySock,sql))
   {
    GetMyErr();
    return -1;
   }
   return mysql_affected_rows(MySock);
  }
  else
  {
    GetMyErr();
    return -1;
  }
}

MYSQL_RES * TMySQLObj::DoQuery(char *sql)
{
  PSQLRes = NULL;
  if ( MySock )
  {
    if (mysql_query(MySock,sql)) return NULL;
    else
    {
     PSQLRes =mysql_store_result(MySock);
     return PSQLRes;
    }
  }
  else
  {
    GetMyErr();
    return NULL;
  }
}


int TMySQLObj::FindFirstDatabase(void)
{
  if (PSQLRes) mysql_free_result(PSQLRes) ;
  PSQLRes =NULL;
  PMyRow =NULL;
  ResFindDB=0;
  NumRows=0;
  if(Connected)
//    sprintf(szSQL, "show TABLES FROM %s", MyDB);
    if (DoQuery("SHOW DATABASES"))
    {
        if (NumRows=mysql_num_rows(PSQLRes))
        {
          PMyRow = mysql_fetch_row(PSQLRes);
          if (PMyRow)
          {
               sprintf(FindName, "%s",PMyRow[0]) ;
               ResFindDB++;
          }
        }
    } else FindName[0]=0;
  return NumRows;
}

int TMySQLObj::FindNextDatabases(void)
{
    FindName[0]=0;
    if (PSQLRes)
    {
      if (ResFindDB)
      {
         PMyRow  = mysql_fetch_row(PSQLRes);
         if (PMyRow == NULL)
         {
           mysql_free_result(PSQLRes) ;
           PSQLRes =NULL;
           PMyRow =NULL;
           ResFindDB=0;
           return 0;
         }
         if ( (PMyRow[0]==NULL) || (!strlen(PMyRow[0])) )
         {
           ResFindDB=0;
           return 0;
         }
         else
         {
           sprintf(FindName, "%s",PMyRow[0]) ;
           ResFindDB++;
         }
      }
      return ResFindDB;
    }
    return 0;
}

int TMySQLObj::FindFirstTable(char *database)
{
  if (PSQLRes) mysql_free_result(PSQLRes) ;
  PSQLRes =NULL;
  PMyRow =NULL;
  ResFindTb=0;
  NumRows=0;

  if(Connected)
    sprintf(FindName, "show TABLES FROM %s", database);
    if (DoQuery(FindName))
    {
        if (NumRows=mysql_num_rows(PSQLRes))
        {
          PMyRow = mysql_fetch_row(PSQLRes);
          if (PMyRow)
          {
               sprintf(FindName, "%s",PMyRow[0]) ;
               ResFindTb++;
          }
        }
    } else FindName[0]=0;
  return NumRows;
}

int TMySQLObj::FindNextTable(void)
{
    FindName[0]=0;
    if (PSQLRes)
    {
      if (ResFindTb)
      {
         PMyRow  = mysql_fetch_row(PSQLRes);
         if (PMyRow == NULL)
         {
           mysql_free_result(PSQLRes) ;
           PSQLRes =NULL;
           PMyRow =NULL;
           ResFindTb=0;
           return 0;
         }
         if ( (PMyRow[0]==NULL) || (!strlen(PMyRow[0])) )
         {
           ResFindTb=0;
           return 0;
         }
         else
         {
           sprintf(FindName, "%s",PMyRow[0]) ;
           ResFindTb++;
         }
      }
      return ResFindTb;
    }
    return 0;
}


void TMySQLObj::FreeResult(void)
{
  if (PSQLRes) mysql_free_result(PSQLRes);
}

