(* Copyright (c) by DATATEC Computer u. Elektronik GmbH

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *)

unit BackDemoMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, CheckLst, ComCtrls, ExtCtrls, MySQLBackUp, Spin;

type
  TFMain = class(TForm)
    Panel1: TPanel;
    BtClose: TBitBtn;
    PagCon: TPageControl;
    TSLogin: TTabSheet;
    Panel2: TPanel;
    CBTables: TCheckListBox;
    Panel5: TPanel;
    BtSelAll: TSpeedButton;
    BtDeSelAll: TSpeedButton;
    Panel3: TPanel;
    LBDatabase: TListBox;
    Panel4: TPanel;
    pnMain: TPanel;
    lbHost: TLabel;
    lbDb: TLabel;
    lbLogin: TLabel;
    lbPswd: TLabel;
    LbConnect: TLabel;
    edHost: TEdit;
    edDb: TEdit;
    edLogin: TEdit;
    edPswd: TEdit;
    MySQLBackUp1: TMySQLBackUp;
    GroupBox1: TGroupBox;
    CBMulti: TCheckBox;
    CBLock: TCheckBox;
    CBcOpt: TCheckBox;
    BtBackup: TBitBtn;
    BtTableStruct: TBitBtn;
    CBtOpt: TCheckBox;
    CBDrop: TCheckBox;
    EdBackFile: TEdit;
    Label1: TLabel;
    StBar: TStatusBar;
    TSLogFile: TTabSheet;
    Memo1: TMemo;
    CBExtIns: TCheckBox;
    CBProgr: TCheckBox;
    EdInterv: TSpinEdit;
    Label2: TLabel;
    CBHosts: TComboBox;
    Label7: TLabel;
    BtGetProfil: TSpeedButton;
    TSStruct: TTabSheet;
    Splitter1: TSplitter;
    StructMemo: TMemo;
    LBStrTabs: TListBox;
    Splitter2: TSplitter;
    OpenDialog1: TOpenDialog;
    PGBar: TProgressBar;
    BtRestore: TBitBtn;
    BtDiscon: TBitBtn;
    BtConnect: TBitBtn;
    Label3: TLabel;
    BtInfo: TBitBtn;
    BtLiveTest: TBitBtn;
    EdWhere: TEdit;
    CBwhere: TCheckBox;
    procedure btnConnectClick(Sender: TObject);
    procedure BtDisconClick(Sender: TObject);
    procedure BtCloseClick(Sender: TObject);
    procedure LBDatabaseDblClick(Sender: TObject);
    procedure BtSelAllClick(Sender: TObject);
    procedure BtDeSelAllClick(Sender: TObject);
    procedure BtTableStructClick(Sender: TObject);
    procedure BtBackupClick(Sender: TObject);
    procedure CBMultiClick(Sender: TObject);
    procedure MySQLBackUp1ServerConnect(Sender: TObject;
      data: TServerInfo);
    procedure MySQLBackUp1MyDataError(Sender: TObject; ErrInfo: TMyErrRec);
    procedure MySQLBackUp1Disconnect(Sender: TObject);
    procedure MySQLBackUp1AfterDump(Sender: TObject; DumpInfo: TMyDumpRec);
    procedure PagConChange(Sender: TObject);
    procedure CBProgrClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtGetProfilClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CBHostsChange(Sender: TObject);
    procedure LBStrTabsDblClick(Sender: TObject);
    procedure BtRestoreClick(Sender: TObject);
    procedure BtInfoClick(Sender: TObject);
    procedure MySQLBackUp1ActionError(Sender: TObject; PrgError: String);
    procedure BtLiveTestClick(Sender: TObject);
    procedure CBwhereClick(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure SetOptions;
  public
    { Public-Deklarationen }
  end;

var
  FMain: TFMain;
  SMyProfil,SMyHost,SMyDB,SUser,SPwd:string;


implementation

{$R *.DFM}

uses Profil,About;


procedure TFMain.btnConnectClick(Sender: TObject);
begin
  with MySQLBackUp1 do begin
      Host := edHost.Text;
      Database := edDB.Text;
      User := edLogin.Text;
      Password :=edPswd.Text;
      Connect;
      if Connected then begin
        if GetDatabases > 0 then
           LBDatabase.Items.Assign(Databases);
        LBDatabase.ItemIndex:=0;
        LBDatabaseDblClick(Self);
      end;
  end;
end;

procedure TFMain.BtDisconClick(Sender: TObject);
begin
  with MySQLBackUp1 do if Connected then DoClose;
end;

procedure TFMain.BtCloseClick(Sender: TObject);
begin
  close;
end;

procedure TFMain.LBDatabaseDblClick(Sender: TObject);
begin
  MySQLBackUp1.WriteLogHeading:=true;
  if LBDatabase.Items.Count < 1 then exit;
  CBTables.clear;
  with MySQLBackUp1 do
    if GetTables(LBDatabase.Items[LBDatabase.ItemIndex]) > 0
       then CBTables.Items.Assign(Tables);
  StBar.SimpleText:='Active Database: -> '+LBDatabase.Items[LBDatabase.ItemIndex];
end;

procedure TFMain.BtSelAllClick(Sender: TObject);
var i:integer;
begin
  for i:=0 to CBTables.Items.Count -1 do
      CBTables.Checked[i]:=true;
end;

procedure TFMain.BtDeSelAllClick(Sender: TObject);
var i:integer;
begin
  for i:=0 to CBTables.Items.Count -1 do
      CBTables.Checked[i]:=false;
end;

procedure TFMain.BtTableStructClick(Sender: TObject);
var s:string;
    i:integer;
begin
  if PagCon.ActivePage = TSStruct then LBStrTabsDblClick(Self)
  else begin
    for i:=0 to CBTables.Items.Count -1 do begin
        if CBTables.Checked[i] then
          with MySQLBackUp1 do begin
            s:=CBTables.Items[i];
            BackFileName:=s+'.sql';
            Database:=LBDatabase.Items[LBDatabase.ItemIndex];
            GetTableStructure(s);
            CBTables.Checked[i]:=false;
          end;
    end;
  end;
end;

procedure TFMain.SetOptions;
begin
  with MySQLBackUp1 do begin
    LockOpt:= CBLock.Checked;
    DropOpt:= CBDrop.Checked;
    tOption:= CBtOpt.Checked;
    cOption:= CBcOpt.Checked;
    MultiTbOpt:=CBMulti.Checked;
    ExtInsOpt :=CBExtIns.Checked;
    if CBwhere.Checked and (trim(EdWhere.text) <> '')
    then begin
       SQLWhere:=EdWhere.text;
       WhereOpt:=true;
    end else WhereOpt:=false;
    ProgressStep:=EdInterv.Value;
  end;
end;


procedure TFMain.BtBackupClick(Sender: TObject);
var s:string;
    TbCount,i:integer;
begin
  try
    if Pos('where', lowercase(EdWhere.text)) > 0  then
       MessageDlg('The " Where " statement may not be contained!', mtError	, [mbOk], 0)
    else begin
      Screen.Cursor:=crHourGlass;
      SetOptions;
      TbCount:=0;
      for i:=0 to CBTables.Items.Count -1 do begin
          if CBTables.Checked[i] then
            with MySQLBackUp1 do begin
              if CBMulti.Checked then s:= trim(EdBackFile.Text)
              else s:=CBTables.Items[i]+'.sql';
              BackFileName:=s;
              Database:=LBDatabase.Items[LBDatabase.ItemIndex];
              if MakeBackUp(CBTables.Items[i]) then begin
                CBTables.Checked[i]:=false;
                inc(TbCount);
              end;
            end;
      end;
      Screen.Cursor:=crDefault;
      MessageDlg(IntToStr(TbCount)+' Tables saved.', mtInformation, [mbOk], 0);
      StBar.SimpleText:='Active Database: -> '+LBDatabase.Items[LBDatabase.ItemIndex];
    end;
  except
  Screen.Cursor:=crDefault;
  end;
end;

procedure TFMain.CBMultiClick(Sender: TObject);
begin
  EdBackFile.Enabled:=CBMulti.Checked;
end;

procedure TFMain.MySQLBackUp1ServerConnect(Sender: TObject;
  data: TServerInfo);
begin
//  showmessage('Connected with: '+data.Host+' User:'+data.User);
  LbConnect.Caption:='Connected';
  LbConnect.Color:=$0080FF80;
  BtBackup.Enabled:=true;
  BtRestore.Enabled:=true;
  BtTableStruct.Enabled:=true;
  BtConnect.Enabled:=false;
  BtDiscon.Enabled:=true;

end;

procedure TFMain.MySQLBackUp1MyDataError(Sender: TObject;
  ErrInfo: TMyErrRec);
begin
  showmessage('MySQL-Error: '+IntToStr(ErrInfo.MyErrNo)+' / '+ErrInfo.MyErrStr);
end;

procedure TFMain.MySQLBackUp1Disconnect(Sender: TObject);
begin
  LBDatabase.clear;
  CBTables.clear;
  BtBackup.Enabled:=false;
  BtRestore.Enabled:=false;
  BtTableStruct.Enabled:=false;
  BtConnect.Enabled:=true;
  BtDiscon.Enabled:=false;
  LbConnect.Caption:='DisConnected';
  LbConnect.Color:=$008080FF;
end;

procedure TFMain.MySQLBackUp1AfterDump(Sender: TObject;
  DumpInfo: TMyDumpRec);
begin
  StBar.SimpleText:=' Dumping table: "'+DumpInfo.Table+'" dumping records: '+IntToStr(DumpInfo.Records);
end;

procedure TFMain.PagConChange(Sender: TObject);
begin
  try
    if PagCon.ActivePage = TSLogFile then begin
       with MySQLBackUp1 do
         if FileExists(LogFileName)
            then Memo1.Lines.LoadFromFile(LogFileName);
    end else if PagCon.ActivePage = TSStruct then begin
        LBStrTabs.Items.Assign(CBTables.Items);
    end;
  except
  end;
end;


procedure TFMain.CBProgrClick(Sender: TObject);
begin
  if CBProgr.Checked then MySQLBackUp1.ProgressBar:=PGBar
  else MySQLBackUp1.ProgressBar:=nil;
end;


procedure TFMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Screen.Cursor:=crDefault;
end;

procedure TFMain.BtGetProfilClick(Sender: TObject);
begin
   FProfil.Showmodal;
   CBHostsChange(Self);
end;


procedure TFMain.FormShow(Sender: TObject);
begin
  try
    PagCon.ActivePageIndex:=0;
    FProfil.LadeAlleProfile;
    CBHostsChange(Self);
  except
  end;
end;



procedure TFMain.CBHostsChange(Sender: TObject);
begin
  with MySQLBackUp1 do if Connected then DoClose;
  FProfil.LadeProfil(CBHosts.ItemIndex+1);
  edHost.Text:=SMyHost;
  edDB.Text:=SMyDB;
  edLogin.Text:=SUser;
  edPswd.Text:=SPwd;
end;

procedure TFMain.LBStrTabsDblClick(Sender: TObject);
var s:string;
begin
  try
   if LBStrTabs.Items.Count < 1 then exit;
    with MySQLBackUp1 do begin
      MultiTbOpt:=false;
      s:=LBStrTabs.Items[LBStrTabs.ItemIndex];
      BackFileName:='Stru_'+s+'.sql';
      Database:=LBDatabase.Items[LBDatabase.ItemIndex];
      GetTableStructure(s);
      if FileExists(BackFileName) then begin
         StructMemo.Lines.LoadFromFile(BackFileName);
         DeleteFile(BackFileName);
      end;
    end;
  except
  end;
end;


procedure TFMain.BtRestoreClick(Sender: TObject);
var
  Recs:integer;
begin
  try
   if Application.MessageBox('May you really execute the Restore-function?',
       'Table-Restore', MB_OKCANCEL) = ID_OK then
   begin
    Screen.Cursor:=crHourGlass;
    OpenDialog1.InitialDir:=GetCurrentDir;
    if OpenDialog1.Execute then begin
      with MySQLBackUp1 do begin
        Database:=LBDatabase.Items[LBDatabase.ItemIndex];
        RestoreFileName:=OpenDialog1.Filename;
        Recs:=RestoreSQLFile;
      end;
      if Recs >0 then
         MessageDlg(IntToStr(Recs)+' records back-secured.', mtInformation, [mbOk], 0);
    end;
   end;
   Screen.Cursor:=crDefault;
  except
   Screen.Cursor:=crDefault;
  end;
end;

procedure TFMain.BtInfoClick(Sender: TObject);
begin
  with TAboutBox.Create(self) do showmodal;
end;

procedure TFMain.MySQLBackUp1ActionError(Sender: TObject;
  PrgError: String);
begin
 MessageDlg(PrgError, mtError	, [mbOk], 0);
end;

procedure TFMain.BtLiveTestClick(Sender: TObject);
var MsgStr:string;
begin
 if MySQLBackUp1.IsTheServerAlive then MsgStr:= 'The server is alive.'
 else  MsgStr:= 'The connection was lost.';
 MessageDlg(MsgStr, mtInformation, [mbOk], 0);
end;

procedure TFMain.CBwhereClick(Sender: TObject);
begin
 EdWhere.visible:= CBwhere.Checked;
end;

end.
